#include <PubSubClient.h>
#include <SPI.h>
#include <Ethernet.h>
#include <SimpleDHT.h>
#include <DHT.h>
#include <MFRC522.h>


byte mac[] = {0xDE, 0xDA, 0xBE, 0xEB, 0xFE, 0xED};
IPAddress dnServer(192, 168, 1, 1);
IPAddress gateway(192, 168, 1, 1);
IPAddress subnet(255, 255, 255, 0);
IPAddress ip(192, 168, 1, 225);

const char* mqtt_server="192.168.1.200";

//****************************Parámetros de RFID***********************************************
#define SS_PIN 53
#define RST_PIN 8
 
MFRC522 rfid(SS_PIN, RST_PIN);

MFRC522::MIFARE_Key key; 
// Init array that will store new NUID 
byte nuidPICC[3];
#define NEW_UID {0xDE, 0xAD, 0xBE, 0xEF}
String UIDstring;

//**********************************************************************************************

EthernetClient ethClient;
PubSubClient mqttClient(ethClient);

#define DHTTYPE DHT22   // DHT 22  (AM2302), AM2321
#define LIGHT A9
#define valCO2 A0
#define valQoA A2
#define fuego A4
#define fuegod 10
#define LED 6
#define WATER 12
#define LED_LIGTH_PASILLO 22
#define LED_LIGTH_BEDROOM 24
#define LED_HEAT_BEDROOM 26
#define LED_ALARM_1 28
#define LED_ALARM_2 30
#define LED_LIGTH_LIVING 32
#define LED_HEAT_LIVING 34
#define AVISADOR 36
#define ALARM_ON 37
#define ALARM_OFF 35


float hum=0, temp=0;
unsigned long previousMillis = 0 ; // Almacena el valor de tiempo en la ultima lectura
unsigned long previousMillisAlarm = 0 ; // Almacena el valor de tiempo en la ultima lectura
const long interval = 30000; // Intervalo entre lecturas del sensor
int normalizedValue;
const int DHTPin = 43;
DHT dht(DHTPin, DHTTYPE);
int estadoagua=0;
int estadoalarma;

 
void callback(char* topic, byte* payload, unsigned int length) {
//**********************pasillo*******************************
if (strcmp ("myhome/pasillo/luz", topic) == 0){
 // Defaults to QoS 0 subscription:
  Serial.print("Mensaje recibido [");
  Serial.print(topic);
  Serial.print("] ");
  for (int i=0;i<length;i++) {
    char receivedChar = (char)payload[i];
    Serial.print(receivedChar);
 if (receivedChar == '1')
  digitalWrite(LED_LIGTH_PASILLO, HIGH);
  if (receivedChar == '0')
   digitalWrite(LED_LIGTH_PASILLO, LOW);
  }
  Serial.println();
}
//**********************habitación de invitados*******************************
if (strcmp ("myhome/hab2/luz", topic) == 0){
 // Defaults to QoS 0 subscription:
  Serial.print("Mensaje recibido [");
  Serial.print(topic);
  Serial.print("] ");
  for (int i=0;i<length;i++) {
    char receivedChar = (char)payload[i];
    Serial.print(receivedChar);
 if (receivedChar == '1')
  digitalWrite(LED_LIGTH_BEDROOM, HIGH);
  if (receivedChar == '0')
   digitalWrite(LED_LIGTH_BEDROOM, LOW);
  }
  Serial.println();
}
if (strcmp ("myhome/hab2/heat", topic) == 0){
 // Defaults to QoS 0 subscription:
  Serial.print("Mensaje recibido [");
  Serial.print(topic);
  Serial.print("] ");
  for (int i=0;i<length;i++) {
    char receivedChar = (char)payload[i];
    Serial.print(receivedChar);
 if (receivedChar == '1')
  digitalWrite(LED_HEAT_BEDROOM, HIGH);
  if (receivedChar == '0')
   digitalWrite(LED_HEAT_BEDROOM, LOW);
  }
  Serial.println();
}
//**********************alarma*******************************
if (strcmp ("myhome/rfidin", topic) == 0){
 // Defaults to QoS 0 subscription:
  Serial.print("Mensaje recibido [");
  Serial.print(topic);
  Serial.print("] ");
  for (int i=0;i<length;i++) {
    char receivedChar = (char)payload[i];
    Serial.print(receivedChar);
 if (receivedChar == '1'){
  digitalWrite(ALARM_ON, HIGH);
  delay(500);
    digitalWrite(ALARM_ON, LOW);
    estadoalarma=1;}

  if (receivedChar == '0'){
   digitalWrite(ALARM_OFF, HIGH);
    delay(500);
    digitalWrite(ALARM_OFF, LOW);
    estadoalarma=0;}
  }
  Serial.println();
}



//**********************salón*******************************
if (strcmp ("myhome/living/luz", topic) == 0){
 // Defaults to QoS 0 subscription:
  Serial.print("Mensaje recibido [");
  Serial.print(topic);
  Serial.print("] ");
  for (int i=0;i<length;i++) {
    char receivedChar = (char)payload[i];
    Serial.print(receivedChar);
 if (receivedChar == '1')
  digitalWrite(LED_LIGTH_LIVING, HIGH);
  if (receivedChar == '0')
   digitalWrite(LED_LIGTH_LIVING, LOW);
 
  }
  Serial.println();
}
if (strcmp ("myhome/living/heat", topic) == 0){
 // Defaults to QoS 0 subscription:
  Serial.print("Mensaje recibido [");
  Serial.print(topic);
  Serial.print("] ");
  for (int i=0;i<length;i++) {
    char receivedChar = (char)payload[i];
    Serial.print(receivedChar);
 if (receivedChar == '1')
  digitalWrite(LED_HEAT_LIVING, HIGH);
  if (receivedChar == '0')
   digitalWrite(LED_HEAT_LIVING, LOW);
  }
  Serial.println();
}
}
 
void reconnect() {
  while (!mqttClient.connected()) {
    Serial.print("Intentando conectarse...");
    if (mqttClient.connect("Cocina")) {
      Serial.println("conectado");
      mqttClient.subscribe("ledStatus");
    } else {
      Serial.print("falla, rc=");
      Serial.print(mqttClient.state());
      Serial.println(" reintentaremos en 5 segundos");
      delay(5000);
    }
  }
}

// ------------------------------------------------------------------
void printHex(byte *buffer, byte bufferSize) {
  for (byte i = 0; i < bufferSize; i++) {
    Serial.print(buffer[i] < 0x10 ? " 0" : " ");
    Serial.print(buffer[i], HEX);
  }
  Serial.println();
}
void printDec(byte *buffer, byte bufferSize) {
  UIDstring = "";
  for (byte i = 0; i < bufferSize; i++) {
    Serial.print(buffer[i] < 0x10 ? " 0" : " ");
    Serial.print(buffer[i], DEC);

    UIDstring = UIDstring + String(rfid.uid.uidByte[i]);
      }

Serial.println();
Serial.print(UIDstring);
}
//------------------------------------------------------------------

void leer_rfid() {

  // Buscamos tarjetas
  if ( ! rfid.PICC_IsNewCardPresent())
    return;

  // SI la encuentra la leemos
  if ( ! rfid.PICC_ReadCardSerial())
    return;

  Serial.print(F("PICC type: "));
  MFRC522::PICC_Type piccType = rfid.PICC_GetType(rfid.uid.sak);
  Serial.println(rfid.PICC_GetTypeName(piccType));

  // Check is the PICC of Classic MIFARE type
  if (piccType != MFRC522::PICC_TYPE_MIFARE_MINI &&  
    piccType != MFRC522::PICC_TYPE_MIFARE_1K &&
    piccType != MFRC522::PICC_TYPE_MIFARE_4K) 
      {
        Serial.println(F("Your tag is not of type MIFARE Classic."));
        return;
      }

  if (rfid.uid.uidByte[0] != nuidPICC[0] || 
    rfid.uid.uidByte[1] != nuidPICC[1] || 
    rfid.uid.uidByte[2] != nuidPICC[2] || 
    rfid.uid.uidByte[3] != nuidPICC[3] ) 
    {
        Serial.println(F("A new card has been detected."));
    
        Serial.println(F("The NUID tag is:"));
        Serial.print(F("In hex: "));
        printHex(rfid.uid.uidByte, rfid.uid.size);

       
        Serial.print(F("In dec: "));
        printDec(rfid.uid.uidByte, rfid.uid.size);
        Serial.println();

//**********
char UID_str[12];
// Convierte los valores de temperatura y humedad a cadena de caracteres
UIDstring.toCharArray(UID_str, 12);
//***************

      mqttClient.publish("myhome/rfid", UID_str);
     
       rfid.PICC_HaltA();
       rfid.PCD_StopCrypto1();
    }
    delay(600);
}
//***********************************************************************

//Utility function to read data from DHT11 and ligth

void readDHT22(){ 
 //Serial.println("Reading data from DHT22...");
 // Reading temperature for humidity takes about 250 milliseconds!
 
 // Sensor readings may also be up to 2 seconds ’old’ (it’s a very slow sensor)

dht.begin();
 
 // Wait a few seconds between measurements.
 delay(2000);

  // Reading temperature or humidity takes about 250 milliseconds!
  hum = dht.readHumidity();
  temp = dht.readTemperature();

  if (isnan(hum) || isnan(temp)) {
   // Serial.println("Failed to read from DHT sensor!");
    return;
  }

  Serial.print("Humidity: ");
  Serial.print(hum);
  Serial.print(" %\t");
  Serial.print("Temperature: ");
  Serial.print(temp);
  Serial.println(" *C ");


int value = analogRead(LIGHT);
normalizedValue = map(value, 0, 1023, 0, 99);
  Serial.println(normalizedValue);

}

void mqttPublish(){
  unsigned long currentMillis = millis();
char temp_str[3], hum_str[3], lux_str[3];
if (currentMillis - previousMillis >= interval){
previousMillis = currentMillis;

 readDHT22(); //leemos los datos del sensor
  
// Convierte los valores de temperatura y humedad a cadena de caracteres
 dtostrf(temp,2,1,temp_str);
 dtostrf(hum,2,1,hum_str);
 dtostrf(normalizedValue,2,1,lux_str);
 
  
 //Envio de datos con MQTT
 Serial.println ("DTH sensor read and transmitted");


 Serial.print (" Estado MQTT - ");
       Serial.print(mqttClient.state());
 Serial.println (" - 0 es conectado");



 mqttClient.publish("myhome/cocina/temperature", temp_str);
 mqttClient.publish("myhome/cocina/humidity", hum_str);
 mqttClient.publish("myhome/cocina/lux", lux_str);

 
 // Guarda el valor de la ultima lectura
 previousMillis = millis();
}
}

void alarmas(){
  char CO2_str[3], QoA_str[3];
unsigned long currentMillis = millis();
const long interval2 = 10000; // Intervalo entre lecturas del sensor
int Fire=1000;

if (currentMillis - previousMillisAlarm >= interval2){
previousMillisAlarm = currentMillis;

  int CO2 = analogRead(valCO2);
  Serial.print("Valor de CO2: ");
  Serial.print(CO2,DEC);//Print the value to serial port
  Serial.println("ppm");
   dtostrf(CO2,2,0,CO2_str);
   mqttClient.publish("myhome/cocina/CO2", CO2_str);
if(CO2 > 300)
   {
    while((CO2 > 300) && (Fire > 40)){
      Serial.println("Detección");  
      digitalWrite(LED_ALARM_2, HIGH);
      digitalWrite(LED_ALARM_1, LOW);
      delay(1000); // retardo en milisegundos
      digitalWrite(LED_ALARM_2, LOW);
      digitalWrite(LED_ALARM_1, HIGH);
      delay(1000); 
      CO2 = analogRead(valCO2);
      Fire = analogRead(fuego);}
   }
   else{
    digitalWrite(LED_ALARM_2, LOW);
      digitalWrite(LED_ALARM_1, LOW);
   }

  int QoA = analogRead(valQoA);
  Serial.print("Valor de Calidad del aire: ");
  Serial.print(QoA);
  Serial.println("ppm");
  dtostrf(QoA,2,0,QoA_str);
   mqttClient.publish("myhome/cocina/QoA", QoA_str);
 if(QoA > 300)
     {
    while((QoA > 300) && (Fire > 40)){
      Serial.println("Detección");  
      digitalWrite(LED_ALARM_2, HIGH);
      digitalWrite(LED_ALARM_1, LOW);
      delay(700); // retardo en milisegundos
      digitalWrite(LED_ALARM_2, LOW);
      digitalWrite(LED_ALARM_1, HIGH);
      delay(700); 
      QoA = analogRead(valQoA);
      Fire = analogRead(fuego);
      }
   }
   else{
    digitalWrite(LED_ALARM_2, LOW);
      digitalWrite(LED_ALARM_1, LOW);
   }

    
  Fire = analogRead(fuego);
  Serial.print("Valor de Fuego: ");
  Serial.println(Fire);
  if(Fire < 40){
   while(Fire < 40){
      Serial.println("Detección");  
     mqttClient.publish("myhome/cocina/Fire", "FUEGO!!");
      Serial.println("Detección");  
      digitalWrite(LED_ALARM_2, HIGH);
      digitalWrite(LED_ALARM_1, LOW);
      digitalWrite(AVISADOR, HIGH);
      delay(500); // retardo en milisegundos
      digitalWrite(LED_ALARM_2, LOW);
      digitalWrite(LED_ALARM_1, HIGH);
      digitalWrite(AVISADOR, LOW);
      delay(500); 
       Fire = analogRead(fuego);
   }}
   else{
    mqttClient.publish("myhome/cocina/Fire", "-");
     digitalWrite(LED_ALARM_2, LOW);
      digitalWrite(LED_ALARM_1, LOW);
      }
      

 previousMillisAlarm = millis();
}
}

void agua(){

int agua=(analogRead(12));

if (agua>100){
  estadoagua=1;
   mqttClient.publish("myhome/cocina/inundacion", "1");
   digitalWrite(LED_ALARM_2, HIGH);
  }  
 if (agua<99 and estadoagua==1){
  estadoagua=0;
  mqttClient.publish("myhome/cocina/inundacion", "0");
  digitalWrite(LED_ALARM_2, LOW);
  }
  
}

  




void setup() {
  Serial.begin(9600);
  mqttClient.setServer(mqtt_server, 1883);
  mqttClient.setCallback(callback);

  pinMode(LED, OUTPUT);
  pinMode(WATER, INPUT);
  pinMode(fuego, INPUT);

 pinMode(LED_LIGTH_PASILLO, OUTPUT);
 pinMode(LED_LIGTH_BEDROOM, OUTPUT);
 pinMode(LED_HEAT_BEDROOM, OUTPUT);
 pinMode(LED_ALARM_1, OUTPUT);
 pinMode(LED_ALARM_2, OUTPUT);
 pinMode(LED_LIGTH_LIVING, OUTPUT);
 pinMode(LED_HEAT_LIVING, OUTPUT);
 pinMode(AVISADOR, OUTPUT);

//**********************RFID**********************
SPI.begin();          // Init SPI bus
  rfid.PCD_Init();      // Init MFRC522 

  for (byte i = 0; i < 6; i++) 
    {  key.keyByte[i] = 0xFF;
    }

  Serial.println(F("This code scan the MIFARE Classsic NUID."));
  Serial.print(F("Using the following key:"));
  printHex(key.keyByte, MFRC522::MF_KEY_SIZE);
//***********************************************************
}

 
void loop() {
  if (!mqttClient.connected()) {
    // initialize the ethernet device
  Ethernet.begin(mac, ip, dnServer, gateway, subnet);
  //print out the IP address
  Serial.print("IP = ");
  Serial.println(Ethernet.localIP()); 
    reconnect();
  mqttClient.subscribe("myhome/#");

  }
if (estadoalarma==1){
  digitalWrite(ALARM_ON, HIGH);
  delay(500);
    digitalWrite(ALARM_ON, LOW);
}
  mqttPublish(); // Publica los datos con el protocolo MQTT
 alarmas();
 agua();
 leer_rfid();

 delay (300) ;

   mqttClient.loop();
   
}

